#include "fpp.h"
#include <math.h>

#define MATCH(s,t)	(stricmp(s,t) == 0)

const char *
factor(VOID_ARG)
{
    const char *e;
    char *ee_save[MAXLINE+1];
    char *expression_save[MAXLINE+1];
    int k;				/* loop index */
    int keorg = ke;			/* for debug output */
    int ke_save;
    int keorg_save;
    int ne_save;

    if (MATCH(ee[ke],"!"))		/* unary not */
    {
	ke++;
	e = dtos((atof(expr()) == 0.0) ? 1.0 : 0.0);
    }
    else if (MATCH(ee[ke],"-"))		/* unary minus */
    {
	ke++;
	e = dtos((double)(-atof(expr())));
    }
    else if (MATCH(ee[ke],"+"))		/* unary plus */
    {
	ke++;
	e = expr();
    }
    else if (MATCH(ee[ke],"defined"))
    {
	ke++;
	e = defined();
    }
    else if (MATCH(ee[ke],"("))
    {
	ke++;
	e = expr();
	if (!MATCH(ee[ke++],")"))
	    error("Missing right parenthesis in expression",0);
    }
    else			/* expect .TRUE., .FALSE., or macro name */
    {
	(void)number(ee[ke]);
	if (RLENGTH > 0)		/* then got number */
	    e = ee[ke++];
	else if (MATCH(ee[ke],".true.")) /* logical constant */
	{
	    ke++;
	    e = "1";
	}
	else if (MATCH(ee[ke],".false.")) /* logical constant */
	{
	    ke++;
	    e = "0";
	}
	else				/* must be name*/
	{
	    e = getdef(ee[ke++]);	/* get its definition */
	    if (e == (const char*)NULL)
		e = "";
	    else			/* definitions may contain #(...) */
	    {
		/* To simplify the expression evaluator, ne, ke, and ee[]
		   are kept in global storage.  This is the one place where
		   we need recursive evaluation that would destroy the
		   global values; to prevent that, we save them, do the
		   evaluation, and then restore the original values. */
		ne_save = ne;
		ke_save = ke;
		keorg_save = keorg;
		memcpy((void*)ee_save,(void*)ee,sizeof(ee_save));
		memcpy((void*)expression_save,(void*)expression,
		       sizeof(expression_save));
		e = Strdup(expand(e));
		ne = ne_save;
		ke = ke_save;
		keorg = keorg_save;
		memcpy((void*)ee,(void*)ee_save,sizeof(ee_save));
		memcpy((void*)expression,(void*)expression_save,
		       sizeof(expression_save));
	    }
	}
    }
    if (fpp_debug)
    {
	FPRINTF(stddbg,"\t\tDEBUG: Factor:");
	for (k = keorg; k < ke; ++k)
	    FPRINTF(stddbg," ee[%d] = [%s]",k,ee[k]);
	FPRINTF(stddbg," -> [%s]\n",e);
	FFLUSH(stddbg);
    }
    return e;
}
