#if !defined(FPPSTDLIB_H)
#define FPPSTDLIB_H

#include "args.h"			/* for ARGS() and STDC definitions */

#if STDC || sun
#include <stdlib.h>
#endif /* STDC || sun */

#if __TURBOC__
#include <stddef.h>
#include <stdlib.h>
#include <dir.h>			/* for getcwd() prototype */
#endif

#if defined(_POSIX_SOURCE) || defined(_XOPEN_SOURCE)
#if __NeXT__
#include <libc.h>
#else
#include <unistd.h>
#endif /* __NeXT__ */
#endif /* defined(_POSIX_SOURCE) || defined(_XOPEN_SOURCE) */

/* Supply declarations for a few library functions that are often
absent from system header files.  These are all defined as C
functions, even in a C++ environment.  */

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif
int			access ARGS((const char *path_, int amode_));

#if !(__STDC__ || __APOGEE__)
char			*getenv ARGS((const char *envvar_));
#endif /* !(__STDC__ || __APOGEE__) */

#if defined(__hppa)
int			gethostname ARGS((char *name_, size_t namelen_));
#else
int			gethostname ARGS((char *name_, int namelen_));
#endif

#if defined(ardent)
char			*getcwd ARGS((char *buf_, int size_));
char			*getlogin ARGS((void));
#endif

#if defined(__host_mips) && defined(__mips) /* MIPS RC-3xxx and RC-6xxx */
#define getcwd(buf,size) getwd(buf)
char			*getwd ARGS((char *buf_));
char			*getlogin ARGS((void));
#endif

#if defined(_IBMR2)
struct passwd		*getpwnam ARGS((const char* name_));
		/* missing from some AIX pwd.h (before version 2.3.x) */
#endif /* defined(_IBMR2) */

#if defined(__NeXT__)
#define getcwd(buf,size) getwd(buf)
#endif /* defined(__NeXT__) */

#if !defined(__NeXT__)
unsigned int		sleep ARGS((unsigned int seconds_));
#endif

#if defined(__host_mips)
char			*tmpnam(char * filename_);
					/* missing from BSD43 headers */
#endif

#if defined(__cplusplus) || defined(c_plusplus)
};
#endif

#if !defined(EXIT_FAILURE)
#define EXIT_FAILURE	1
#endif

#if !defined(EXIT_SUCCESS)
#define EXIT_SUCCESS	0
#endif

#if defined(ABS)
#undef ABS
#endif
#define ABS(x)		(((x) < 0) ? (-(x)) : (x))

#if defined(MAX)
#undef MAX
#endif
#define MAX(a,b)	((a) < (b) ? (b) : (a))

#if defined(MIN)
#undef MIN
#endif
#define MIN(a,b)	((a) > (b) ? (b) : (a))

#if defined(_AIX) || defined(__solaris) || defined(SVR4)
#if !defined(unix)
#define unix	1
#endif /* !defined(unix) */
#endif /* defined(_AIX) || defined(__solaris) || defined(SVR4) */

#endif /* !defined(FPPSTDLIB_H) */
